# The role object

A role object is returned as part of the response body of each successful create, list, retrieve or update API call to the `/api/roles` endpoint.

## Fields

| Field                                          | Type       | Description                                                                                                                                                                                         |
| ---------------------------------------------- | ---------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **`type`**                                     | `string`   | `roles`                                                                                                                                                                                             |
| **`id`**                                       | `string`   | The role unique identifier.                                                                                                                                                                         |
| links.**`self`**                               | `string`   | The role endpoint URL.                                                                                                                                                                              |
| attributes.**`name`**                          | `string`   | The role name.                                                                                                                                                                                      |
| attributes.**`kind`**                          | `string`   | The kind of role, one of: `custom`, `admin`, `read_only`                                                                                                                                            |
| attributes.**`_add_missing_base_permissions`** | `boolean`  | Send this attribute if you want to update the role base permissions.                                                                                                                                |
| attributes.**`created_at`**                    | `datetime` | Time at which the resource was created.                                                                                                                                                             |
| attributes.**`updated_at`**                    | `datetime` | Time at which the resource was last updated.                                                                                                                                                        |
| attributes.**`reference`**                     | `string`   | A string that you can use to add any external identifier to the resource. This can be useful for integrating the resource to an external system, like an ERP, a marketing tool, a CRM, or whatever. |
| attributes.**`reference_origin`**              | `string`   | Any identifier of the third party system that defines the reference code.                                                                                                                           |
| attributes.**`metadata`**                      | `object`   | Set of key-value pairs that you can attach to the resource. This can be useful for storing additional information about the resource in a structured format.                                        |
| relationships.**`organization`**               | `object`   | The organization associated to the role.                                                                                                                                                            |
| relationships.**`permissions`**                | `array`    | The permissions associated to the role.                                                                                                                                                             |
| relationships.**`memberships`**                | `array`    | The memberships associated to the role.                                                                                                                                                             |
| relationships.**`api_credentials`**            | `array`    | The API credentials associated to the role.                                                                                                                                                         |
| relationships.**`versions`**                   | `array`    | The associated changes.                                                                                                                                                                             |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.commercelayer.io/provisioning/api-reference/roles/object.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
